class PGlobal { // singleton : pglobal
  boolean debug=false;
  PFont font;
  int theTextSize=18;
}
PGlobal pglobal = new PGlobal();

class Events { // singleton : events
  //ArrayList<Node> clicNodes = new ArrayList<Node>();
  Node[] clicEvents= new Node[0];

  void listeningClicEvents(Node node) {
    clicEvents=(Node[]) append(clicEvents, node);
  }

  void clicEvent(float mx, float my) {
    if (pglobal.debug) {
      println("clicEvent !");
    }
    if (clicEvents.length!=0) {
      //for (Node node : clicNodes) node.runClic(mx, my);
      for (int i=0; i<clicEvents.length; i++) {
        clicEvents[i].clicEvent(mx, my);
      }
    }
  }
}
Events events = new Events();

void mousePressed() {
  events.clicEvent(mouseX, mouseY);
}

class Node {
  boolean toRemove=false;
  boolean pause=false;
  void run() { 
    if (pglobal.debug) {
      println("Méthode run() appelée sur Node : non redéfinie !");
      exit();
    }
  }

  void clicEvent(float mx, float my) { 
    if (pglobal.debug) {
      println("Méthode runClic("+mx+","+my+") appelée sur Node : non redéfinie !");
      exit();
    }
  }
}

class Nodes extends Node {
  //ArrayList<Node> nodes = new ArrayList<Node>();
  Node[] nodes= new Node[0];

  void add(Node node) {
    //nodes.add(node);
    nodes=(Node[]) append(nodes, node);
  }

  void run() {
    //  if (nodes.size()!=0) {
    //    //for (Node node : nodes) node.run();
    //    for (int i=0;i<nodes.size();i++) {
    //      if (nodes.get(i).toRemove) {
    //        nodes.remove(i);
    //      }
    //      else {
    //        nodes.get(i).run();
    //      }
    //    }
    //  }
    //}
    if (pause==false) {
      // Suppression des nodes toRemove de temps à autre
      // TODO à réécrire pour que ce soit plus rapide
      if (nodes.length>10) {
        Node[] nodes2=nodes;
        nodes=new Node[0];
        for (int i=0; i<nodes2.length; i++) {
          if (nodes2[i].toRemove==false) {
            nodes=(Node[]) append(nodes, nodes2[i]);
          }
        }
      }
      if (nodes.length!=0) {
        for (int i=0; i<nodes.length; i++) {
          if (nodes[i].toRemove==false) {
            nodes[i].run();
          }
        }
      }
    }
  }
}

class Node2D extends Node {
  float x, y;
  Node2D(float x, float y) {
    this.x=x;
    this.y=y;
  }
}

class Area2D extends Node2D {
  float shapeRadius;

  Area2D(float x, float y) {
    super(x, y);
    shapeRadius=20;
  }

  Area2D(float x, float y, float radius) {
    super(x, y);
    this.shapeRadius=radius;
  }  

  boolean collide(Area2D a) {
    if (dist(x, y, a.x, a.y)<=shapeRadius+a.shapeRadius) {
      return true;
    } else {
      return false;
    }
  }

  void run() { 
    if (pause==false) {
      display();
      if (pglobal.debug) {
        noFill();
        stroke(255);
        circle(x, y, 2*shapeRadius);
      }
    }
  }  

  void display() {
  }
}

class Sprite2D extends Area2D {
  float vx, vy;

  Sprite2D(float x, float y) {
    super(x, y);
    this.vx=0;
    this.vy=0;
  }
  Sprite2D(float x, float y, float radius) {
    super(x, y, radius);
    this.vx=0;
    this.vy=0;
  }

  void run() {
    x+=vx;
    y+=vy;
    super.run();
  }
}

class Button extends Node2D {
  float dx, dy;
  color baseColor=color(57, 99, 170); // un bleu
  color overColor=color(174, 90, 193); // un violet
  String textButton;
  //int MARGE=10;
  boolean toInit=true; // Inscription à Events lors du premier passage dans run()

  Button(float x, float y, float dx, float dy, String t) {
    super(x, y);
    this.dx=dx;
    this.dy=dy;
    this.textButton=t;
  }

  boolean mOver(float mx, float my) {
    return ((mx >= x) && (mx <= x + dx) &&
      (my >= y) && (my <= y + dy));
  }

  void display() {
    rectMode(CORNER);
    if (mOver(mouseX, mouseY)) fill(overColor); 
    else fill(baseColor);
    noStroke();
    rect(x, y, dx, dy);
    textAlign(CENTER, CENTER);
    fill(0);
    textSize(pglobal.theTextSize);
    rectMode(CENTER);
    text(textButton, x+dx/2, y+dy/2,dx, dy);
  }

  void run() {
    // l'ajout doit se faire quand l'objet est complètement construit donc pas dans le constructeur
    if (toInit) {
      events.listeningClicEvents(this);
      toInit=false;
    }
    if (pause==false)
      display();
  }

  void clicEvent(float mx, float my) { 
    if (mOver(mx, my)) {
      action();
    }
  }

  void action() {
    println("Méthode action() dans Button non redéfinie !");
    exit();
  }
}

class SpriteImage extends Sprite2D {
  PImage image;
  float scale;

  SpriteImage(float x, float y, float radius, PImage image) {
    super(x, y, radius);
    this.image=image;
    this.scale=1;
  }

  void display() {
    imageMode(CENTER);
    image(image, x, y, image.width*scale, image.height*scale);
  }
}

class Collisions extends Node {
  Nodes nodes1, nodes2;
  Collisions(Nodes nodes1, Nodes nodes2) {
    this.nodes1=nodes1;
    this.nodes2=nodes2;
  }
  void run() {
    Area2D n1, n2;
    for (int i=0; i<nodes1.nodes.length; i++) {
      n1 = (Area2D) nodes1.nodes[i];
      for (int j=0; j<nodes2.nodes.length; j++) {
        n2 = (Area2D) nodes2.nodes[j];
        if (n1.toRemove==false && n2.toRemove==false) {
          if (n1.collide(n2)) {
            action(n1, n2);
          }
        }
      }
    }
  }

  void action(Area2D a1, Area2D a2) {
    println("action() dans Collisions non redéfini !");
    exit();
  }
}
